"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOpenConnectionImportExportModal = exports.ConnectionImportExportProvider = void 0;
const react_1 = __importStar(require("react"));
const import_modal_1 = require("./components/import-modal");
const export_modal_1 = require("./components/export-modal");
const ConnectionImportExportServiceContext = react_1.default.createContext(null);
const ConnectionImportExportProvider = ({ children }) => {
    const [importModalState, setImportModalState] = (0, react_1.useState)({
        opened: false,
    });
    const [exportModalState, setExportModalState] = (0, react_1.useState)({
        opened: false,
    });
    const setImportModalOpen = (0, react_1.useCallback)((isOpened, trackingProps) => {
        setImportModalState({
            opened: isOpened,
            trackingProps,
        });
    }, []);
    const openConnectionImportModal = (0, react_1.useCallback)((trackingProps) => {
        setImportModalState({
            opened: true,
            trackingProps,
        });
    }, []);
    const setExportModalOpen = (0, react_1.useCallback)((isOpened, trackingProps) => {
        setExportModalState({
            opened: isOpened,
            trackingProps,
        });
    }, []);
    const openConnectionExportModal = (0, react_1.useCallback)((trackingProps) => {
        setExportModalState({
            opened: true,
            trackingProps,
        });
    }, []);
    const connectionImportExportServiceRef = (0, react_1.useRef)({
        getHandlers() {
            return {
                openConnectionImportModal,
                openConnectionExportModal,
            };
        },
    });
    return (react_1.default.createElement(ConnectionImportExportServiceContext.Provider, { value: connectionImportExportServiceRef.current },
        children,
        react_1.default.createElement(import_modal_1.ImportConnectionsModal, { open: importModalState.opened, setOpen: setImportModalOpen, trackingProps: importModalState.trackingProps }),
        react_1.default.createElement(export_modal_1.ExportConnectionsModal, { open: exportModalState.opened, setOpen: setExportModalOpen, trackingProps: exportModalState.trackingProps })));
};
exports.ConnectionImportExportProvider = ConnectionImportExportProvider;
const useOpenConnectionImportExportModal = (trackingProps) => {
    const service = (0, react_1.useContext)(ConnectionImportExportServiceContext);
    if (!service) {
        return {
            supportsConnectionImportExport: false,
            openConnectionImportExportModal() {
            },
        };
    }
    return {
        supportsConnectionImportExport: true,
        openConnectionImportExportModal(action) {
            if (action === 'import-saved-connections') {
                service.getHandlers().openConnectionImportModal(trackingProps);
            }
            else if (action === 'export-saved-connections') {
                service.getHandlers().openConnectionExportModal(trackingProps);
            }
            else {
                throw new Error(`Unidentified action ${action} passed to handler`);
            }
        },
    };
};
exports.useOpenConnectionImportExportModal = useOpenConnectionImportExportModal;
//# sourceMappingURL=context.js.map