"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOpenModalThroughIpc = exports.useImportExportConnectionsCommon = exports.COMMON_INITIAL_STATE = void 0;
const react_1 = require("react");
const react_2 = require("react");
const hadron_ipc_1 = require("hadron-ipc");
exports.COMMON_INITIAL_STATE = Object.freeze({
    filename: '',
    passphrase: '',
    connectionList: [],
    error: '',
    inProgress: false,
});
function useImportExportConnectionsCommon(setState, finish) {
    const onCancel = (0, react_2.useCallback)(() => {
        finish('canceled');
    }, [finish]);
    const onChangeConnectionList = (0, react_2.useCallback)((connectionList) => {
        setState((prevState) => ({ ...prevState, connectionList }));
    }, []);
    const onChangePassphrase = (0, react_2.useCallback)((passphrase) => {
        setState((prevState) => ({
            ...prevState,
            passphrase,
        }));
    }, []);
    return { onCancel, onChangeConnectionList, onChangePassphrase };
}
exports.useImportExportConnectionsCommon = useImportExportConnectionsCommon;
function useOpenModalThroughIpc(open, openModal, ipcEvent, ipcForTesting = undefined) {
    const ipc = ipcForTesting ?? hadron_ipc_1.ipcRenderer;
    (0, react_1.useEffect)(() => {
        if (ipc?.on && !open) {
            const listener = () => {
                openModal();
            };
            ipc.on(ipcEvent, listener);
            return () => {
                ipc.off(ipcEvent, listener);
            };
        }
    }, [open, openModal]);
}
exports.useOpenModalThroughIpc = useOpenModalThroughIpc;
//# sourceMappingURL=common.js.map